﻿SystemOrganization addCategory: #'Neo4reSt-Client'!

Object subclass: #N4RestClient
	instanceVariableNames: 'rawClient'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Client'!

!N4RestClient class methodsFor: 'instance creation' stamp: 'mu 11/27/2011 22:38'!
rootUri: rootUri
	^ self new rootUri: rootUri; yourself! !

!N4RestClient methodsFor: 'actions-indexers' stamp: 'BernatRomagosa 12/7/2012 14:13'!
addNodeIndex: indexName on: nodeUri key: key value: value
	^self rawClient addNodeIndex: indexName on: nodeUri key: key value: value! !

!N4RestClient methodsFor: 'actions-indexers' stamp: 'mu 2/19/2012 16:39'!
addRelationshipIndex: indexName on: nodeUri key: key value: value
	^self rawClient addRelationshipIndex: indexName on: nodeUri key: key value: value! !

!N4RestClient methodsFor: 'releasing' stamp: 'mu 1/27/2013 16:22'!
close
	self rawClient ifNotNil: [:cli | cli release]
	! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/2/2011 00:11'!
createNode
	^ self rawClient createNode! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 2/13/2012 00:56'!
createNode: properties
	| props |
	props := N4PortableUtil default asProperties: properties.
	^self rawClient createNode: props! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:19'!
createRelationshipAt: nodeId to: uri type: type
	^self rawClient createRelationshipAt: nodeId to: uri type: type! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 2/13/2012 01:00'!
createRelationshipAt: nodeId to: uri type: type properties: properties
	| props |
	props := N4PortableUtil default asProperties: properties.
	^self rawClient createRelationshipAt: nodeId to: uri type: type properties: props! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:19'!
deleteNodeAt: id 
	| response |
	response := self rawClient deleteNodeAt: id.
	^ response code = 204! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/19/2011 23:26'!
deleteNodeIndex: indexName
	^ self rawClient deleteNodeIndex: indexName! !

!N4RestClient methodsFor: 'actions-indexers' stamp: 'mu 2/19/2012 21:06'!
deleteNodeIndexes: indexName
	^ self rawClient deleteNodeIndexes: indexName! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:50'!
deletePropertiesNodeAt: nodeId 
	| response |
	response := self rawClient deletePropertiesNodeAt: nodeId.
	^ response code = 204! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 16:46'!
deletePropertiesRelationshipAt: relId 
	| response |
	response := self rawClient deletePropertiesRelationshipAt: relId.
	^ response code = 204! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/6/2011 23:53'!
deleteProperty: propName nodeAt: nodeId 
	| response |
	response := self rawClient deleteProperty: propName nodeAt: nodeId.
	^ response code = 204! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/6/2011 23:51'!
deleteProperty: propName relationshipAt: relId 
	| response |
	response := self rawClient deleteProperty: propName relationshipAt: relId.
	^ response code = 204! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/6/2011 23:56'!
deleteRelationshipAt: id 
	| response |
	response := self rawClient deleteRelationshipAt: id.
	^ response code = 204! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/19/2011 23:26'!
deleteRelationshipIndex: indexName
	^ self rawClient deleteRelationshipIndex: indexName! !

!N4RestClient methodsFor: 'actions-indexers' stamp: 'mu 2/19/2012 21:06'!
deleteRelationshipIndexes: indexName
	^ self rawClient deleteRelationshipIndexes: indexName! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:20'!
getAllRelationshipsAt: nodeId
	^self rawClient getAllRelationshipsAt: nodeId
	! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/23/2011 13:31'!
getAllRelationshipsAt: nodeId type: type
	^self getAllRelationshipsAt: nodeId types: (Array with: type)! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:20'!
getAllRelationshipsAt: nodeId types: typeCollection
	^self rawClient getAllRelationshipsAt: nodeId types: typeCollection! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:22'!
getInRelationshipsAt: nodeId
	^self rawClient getInRelationshipsAt: nodeId! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/23/2011 13:31'!
getInRelationshipsAt: nodeId type: type
	^self getInRelationshipsAt: nodeId types: (Array with: type)! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:22'!
getInRelationshipsAt: nodeId types: typeCollection
	^self rawClient getInRelationshipsAt: nodeId types: typeCollection! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/13/2011 23:35'!
getNodeAt: id 
	| resp |
	resp := self rawClient getNodeAt: id.
	^resp! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/19/2011 23:20'!
getNodeIndexes
	^ self rawClient getNodeIndexes! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/19/2011 23:58'!
getNodeWithIndex: indexName key: key value: value
	^self rawClient getNodeWithIndex: indexName key: key value: value! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:22'!
getOutRelationshipsAt: nodeId
	^self rawClient getOutRelationshipsAt: nodeId! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/23/2011 13:30'!
getOutRelationshipsAt: nodeId type: type
	^self getOutRelationshipsAt: nodeId types: (Array with: type)! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:22'!
getOutRelationshipsAt: nodeId types: typeCollection
	^self rawClient getOutRelationshipsAt: nodeId types: typeCollection! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:44'!
getPropertiesNodeAt: nodeId 
	^ self rawClient getPropertiesNodeAt: nodeId ! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:22'!
getPropertiesRelationshipAt: relId 
	^ self rawClient getPropertiesRelationshipAt: relId ! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:36'!
getProperty: propName nodeAt: nodeId
	^ self rawClient getProperty: propName nodeAt: nodeId! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:17'!
getProperty: propName relationshipAt: relId
	^ self rawClient getProperty: propName relationshipAt: relId! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/13/2011 23:35'!
getRelationshipAt: id 
	| resp |
	resp := self rawClient getRelationshipAt: id.
	^ resp! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/19/2011 23:20'!
getRelationshipIndexes
	^ self rawClient getRelationshipIndexes! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/7/2011 00:00'!
getRelationshipTypes
	^ self rawClient getRelationshipTypes! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/19/2011 23:59'!
getRelationshipWithIndex: indexName key: key value: value
	^self rawClient getRelationshipWithIndex: indexName key: key value: value! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:21'!
getRelationshipsAt: nodeId direction: direction types: typeCollection
	^ self rawClient getRelationshipsAt: nodeId direction: direction types: typeCollection! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:21'!
getRoot
	^self rawClient getRoot! !

!N4RestClient methodsFor: 'accessing' stamp: 'mu 12/4/2011 15:23'!
portableUtil
	^self rawClient portableUtil! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/24/2011 15:55'!
queryByCypher: queryString
	| resp |
	resp := self rawClient queryByCypher: queryString.
	^self portableUtil readJsonFromResponse: resp! !

!N4RestClient methodsFor: 'actions' stamp: 'sy 6/4/2013 09:27'!
queryByCypher: queryString params: dictionary
	| resp |
	resp := self rawClient queryByCypher: queryString params: dictionary.
	^self portableUtil readJsonFromResponse: resp! !

!N4RestClient methodsFor: 'accessing' stamp: 'mu 12/2/2011 00:10'!
rawClient

	^ rawClient ifNil: [rawClient := N4RestRawClient new]! !

!N4RestClient methodsFor: 'accessing' stamp: 'mu 12/2/2011 00:09'!
rawClient: anObject
	"Set the value of rawClient"

	rawClient := anObject! !

!N4RestClient methodsFor: 'actions-indexers' stamp: 'mu 2/19/2012 21:03'!
removeNodeIndexes: indexName on: nodeId
	^ self rawClient removeNodeIndexes: indexName on: nodeId! !

!N4RestClient methodsFor: 'actions-indexers' stamp: 'mu 2/19/2012 21:03'!
removeNodeIndexes: indexName on: nodeId key: key
	^ self rawClient removeNodeIndexes: indexName on: nodeId key: key! !

!N4RestClient methodsFor: 'actions-indexers' stamp: 'mu 2/19/2012 21:03'!
removeNodeIndexes: indexName on: nodeId key: key value: value
	^ self rawClient removeNodeIndexes: indexName on: nodeId key: key value: value! !

!N4RestClient methodsFor: 'actions-indexers' stamp: 'mu 2/19/2012 21:03'!
removeRelationshipIndexes: indexName on: nodeId
	^ self rawClient removeRelationshipIndexes: indexName on: nodeId! !

!N4RestClient methodsFor: 'actions-indexers' stamp: 'mu 2/19/2012 21:03'!
removeRelationshipIndexes: indexName on: nodeId key: key
	^ self rawClient removeRelationshipIndexes: indexName on: nodeId key: key! !

!N4RestClient methodsFor: 'actions-indexers' stamp: 'mu 2/19/2012 21:03'!
removeRelationshipIndexes: indexName on: nodeId key: key value: value
	^ self rawClient removeRelationshipIndexes: indexName on: nodeId key: key value: value! !

!N4RestClient methodsFor: 'accessing' stamp: 'mu 12/2/2011 00:11'!
rootUri
	^ self rawClient rootUri! !

!N4RestClient methodsFor: 'accessing' stamp: 'mu 12/2/2011 00:11'!
rootUri: uriString
	self rawClient rootUri: uriString! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 2/13/2012 00:54'!
setProperties: properties nodeAt: nodeId
	| props resp |
	props := N4PortableUtil default asProperties: properties.
	resp := self rawClient setProperties: props nodeAt: nodeId.
	^ resp code ~= 404! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 2/13/2012 00:54'!
setProperties: properties relationshipAt: relId
	| props resp |
	props := N4PortableUtil default asProperties: properties.
	resp := self rawClient setProperties: props relationshipAt: relId.
	^ resp code ~= 404! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:32'!
setProperty: propName to: value nodeAt: nodeId 
	| resp |
	resp := self rawClient setProperty: propName to: value nodeAt: nodeId.
	^ resp code ~= 404! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:14'!
setProperty: propName to: value relationshipAt: relId 
	| resp |
	resp := self rawClient setProperty: propName to: value relationshipAt: relId.
	^ resp code ~= 404! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/23/2011 13:06'!
traverseFrom: nodeId using: traversalDescription
	| resp |
	resp := self rawClient traverseFrom: nodeId using: traversalDescription.
	^self portableUtil readJsonFromResponse: resp
! !

Object subclass: #N4RestRawClient
	instanceVariableNames: 'rootUri'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Client'!

!N4RestRawClient class methodsFor: 'instance creation' stamp: 'mu 12/2/2011 00:08'!
rootUri: rootUri
	^ self new rootUri: rootUri; yourself! !

!N4RestRawClient methodsFor: 'actions-indexes' stamp: 'MasashiUmezawa 1/22/2013 02:03'!
addNodeIndex: indexName on: nodeUri key: key value: value
	|json jsonString |
	json := self newNodeIndexJson: nodeUri key: key value: value.
	jsonString := self portableUtil jsonStringFrom: json.
	^ self portableUtil httpJsonPost: (self indexUri / 'node' // indexName) content: jsonString! !

!N4RestRawClient methodsFor: 'actions-indexes' stamp: 'MasashiUmezawa 1/22/2013 02:03'!
addRelationshipIndex: indexName on: relationshipUri key: key value: value
	|json jsonString |
	json := self newRelationshipIndexJson: relationshipUri key: key value: value.
	jsonString := self portableUtil jsonStringFrom: json.
	^ self portableUtil httpJsonPost: (self indexUri / 'relationship' // indexName) content: jsonString! !

!N4RestRawClient methodsFor: 'releasing' stamp: 'mu 1/27/2013 16:20'!
close
	self portableUtil release! !

!N4RestRawClient methodsFor: 'actions' stamp: 'MasashiUmezawa 1/22/2013 01:43'!
createNode
	^ self portableUtil httpJsonPost: self nodeUri! !

!N4RestRawClient methodsFor: 'actions' stamp: 'MasashiUmezawa 1/21/2013 01:10'!
createNode: properties
	| jsonString |
	jsonString := self portableUtil jsonStringFrom: properties.
	^ self portableUtil httpJsonPost: self nodeUri content: jsonString! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/2/2011 00:08'!
createRelationshipAt: nodeId to: uri type: type
	^self createRelationshipAt: nodeId to: uri type: type properties: nil! !

!N4RestRawClient methodsFor: 'actions' stamp: 'MasashiUmezawa 1/22/2013 01:43'!
createRelationshipAt: nodeId to: uri type: type properties: assocs
	|json jsonString |
	json := self newRelationshipJson: uri type: type asString properties: assocs.
	jsonString := self portableUtil jsonStringFrom: json.
	^ self portableUtil httpJsonPost: (self nodeUri // nodeId / 'relationships') content: jsonString! !

!N4RestRawClient methodsFor: 'actions' stamp: 'MasashiUmezawa 1/21/2013 01:11'!
deleteNodeAt: id 
	^ self portableUtil httpJsonDelete: self nodeUri // id! !

!N4RestRawClient methodsFor: 'actions' stamp: 'MasashiUmezawa 1/21/2013 01:12'!
deleteNodeIndex: indexName
	^ self portableUtil httpJsonDelete: self indexUri / 'node' // indexName! !

!N4RestRawClient methodsFor: 'actions-indexes' stamp: 'MasashiUmezawa 1/22/2013 02:19'!
deleteNodeIndexes: indexName
	^ self portableUtil httpJsonDelete: self indexUri / 'node' // indexName ! !

!N4RestRawClient methodsFor: 'actions' stamp: 'MasashiUmezawa 1/21/2013 01:12'!
deletePropertiesNodeAt: nodeId 
	^ self portableUtil httpJsonDelete: self nodeUri // nodeId / 'properties'! !

!N4RestRawClient methodsFor: 'actions' stamp: 'MasashiUmezawa 1/21/2013 01:25'!
deletePropertiesRelationshipAt: relId 
	^ self portableUtil httpJsonDelete: self relationshipUri // relId asString / 'properties'! !

!N4RestRawClient methodsFor: 'actions' stamp: 'MasashiUmezawa 1/21/2013 01:26'!
deleteProperty: propName nodeAt: nodeId 
	^ self portableUtil httpJsonDelete: self nodeUri // nodeId / 'properties' // propName! !

!N4RestRawClient methodsFor: 'actions' stamp: 'MasashiUmezawa 1/21/2013 01:26'!
deleteProperty: propName relationshipAt: relId 
	^ self portableUtil httpJsonDelete: self relationshipUri // relId / 'properties' // propName! !

!N4RestRawClient methodsFor: 'actions' stamp: 'MasashiUmezawa 1/22/2013 01:44'!
deleteRelationshipAt: relId 
	^ self portableUtil httpJsonDelete: self relationshipUri // relId! !

!N4RestRawClient methodsFor: 'actions' stamp: 'MasashiUmezawa 1/21/2013 01:27'!
deleteRelationshipIndex: indexName
	^ self portableUtil httpJsonDelete: self indexUri / 'relationship' // indexName! !

!N4RestRawClient methodsFor: 'actions-indexes' stamp: 'MasashiUmezawa 1/22/2013 02:18'!
deleteRelationshipIndexes: indexName
	^ self portableUtil httpJsonDelete: self indexUri / 'relationship' // indexName! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/2/2011 00:08'!
getAllRelationshipsAt: nodeId
	^self getAllRelationshipsAt: nodeId types: nil! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/2/2011 00:08'!
getAllRelationshipsAt: nodeId types: typeCollection
	^self getRelationshipsAt: nodeId direction: #all types: typeCollection! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/2/2011 00:08'!
getInRelationshipsAt: nodeId
	^self getInRelationshipsAt: nodeId types: nil! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/2/2011 00:08'!
getInRelationshipsAt: nodeId types: typeCollection
	^self getRelationshipsAt: nodeId direction: #in types: typeCollection! !

!N4RestRawClient methodsFor: 'actions' stamp: 'MasashiUmezawa 1/22/2013 01:44'!
getNodeAt: id 
	^ self portableUtil httpJsonGet: self nodeUri // id
		! !

!N4RestRawClient methodsFor: 'actions' stamp: 'MasashiUmezawa 1/21/2013 01:28'!
getNodeIndexes
	^ self portableUtil getJsonFrom: self indexUri / 'node'! !

!N4RestRawClient methodsFor: 'actions' stamp: 'MasashiUmezawa 1/22/2013 01:57'!
getNodeWithIndex: indexName key: key value: value
	^ self portableUtil getJsonFrom: self indexUri / 'node' // indexName // key // value! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/2/2011 00:08'!
getOutRelationshipsAt: nodeId
	^self getOutRelationshipsAt: nodeId types: nil! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/2/2011 00:08'!
getOutRelationshipsAt: nodeId types: typeCollection
	^self getRelationshipsAt: nodeId direction: #out types: typeCollection! !

!N4RestRawClient methodsFor: 'actions' stamp: 'MasashiUmezawa 1/22/2013 01:45'!
getPropertiesNodeAt: nodeId 
	^ self portableUtil getJsonOrEmptyFrom: self nodeUri // nodeId asString / 'properties'! !

!N4RestRawClient methodsFor: 'actions' stamp: 'MasashiUmezawa 1/22/2013 01:46'!
getPropertiesRelationshipAt: relId 
	^ self portableUtil getJsonOrEmptyFrom: self relationshipUri // relId / 'properties'! !

!N4RestRawClient methodsFor: 'actions' stamp: 'MasashiUmezawa 1/22/2013 01:46'!
getProperty: propName nodeAt: nodeId
	^ self portableUtil getJsonFrom: self nodeUri // nodeId / 'properties' // propName! !

!N4RestRawClient methodsFor: 'actions' stamp: 'MasashiUmezawa 1/22/2013 01:47'!
getProperty: propName relationshipAt: relId
	^ self portableUtil getJsonFrom: self relationshipUri // relId / 'properties' // propName! !

!N4RestRawClient methodsFor: 'actions' stamp: 'MasashiUmezawa 1/22/2013 01:47'!
getRelationshipAt: id 
	^ self portableUtil getJsonFrom: self relationshipUri // id
		! !

!N4RestRawClient methodsFor: 'actions' stamp: 'MasashiUmezawa 1/22/2013 01:47'!
getRelationshipIndexes
	^ self portableUtil getJsonFrom: self indexUri / 'relationship'! !

!N4RestRawClient methodsFor: 'actions' stamp: 'MasashiUmezawa 1/22/2013 01:48'!
getRelationshipTypes
	^ self portableUtil getJsonFrom: self relationshipUri / 'types'! !

!N4RestRawClient methodsFor: 'actions' stamp: 'MasashiUmezawa 1/22/2013 01:58'!
getRelationshipWithIndex: indexName key: key value: value
	^ self portableUtil getJsonFrom: self indexUri / 'relationship' // indexName // key // value! !

!N4RestRawClient methodsFor: 'actions' stamp: 'MasashiUmezawa 1/22/2013 01:52'!
getRelationshipsAt: nodeId direction: direction types: typeCollection
	| uriStream |
	uriStream := WriteStream with: (self nodeUri // nodeId) asString.
	uriStream nextPutAll: '/relationships/' ; nextPutAll: (self portableUtil stringFrom: direction).
	(typeCollection isNil or: [typeCollection isEmpty]) ifFalse: [uriStream nextPut: $/.
		typeCollection do: [:each | uriStream nextPutAll: (self portableUtil urlEncodedStringFrom: each)] separatedBy: [uriStream nextPut: $&]
	].

	^ self portableUtil getJsonFrom: uriStream contents! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/2/2011 00:08'!
getRoot
	^ self portableUtil getJsonFrom: self rootUri! !

!N4RestRawClient methodsFor: 'accessing' stamp: 'MasashiUmezawa 1/21/2013 01:15'!
indexUri
	^self rootUri , 'index'! !

!N4RestRawClient methodsFor: 'builder' stamp: 'mu 12/19/2011 23:38'!
newNodeIndexJson: uriOrNodeId key: key value: value
	| uri jsonAssocs |
	jsonAssocs := OrderedCollection new: 3.
	uri := uriOrNodeId asString.
	(self portableUtil string: uri beginsWith: 'http:') ifFalse: [uri := (self rootUri, 'node/', uri)].
	jsonAssocs add: ('uri' -> uri).
	jsonAssocs add: ('key' -> key).
	jsonAssocs add: ('value' -> value).
	^jsonAssocs! !

!N4RestRawClient methodsFor: 'builder' stamp: 'mu 7/6/2013 20:21'!
newQueryJson: queryString params: dictionary
	| jsonAssocs |
	jsonAssocs := OrderedCollection new.
	jsonAssocs add: ('query' -> queryString).
	jsonAssocs add: ('params' -> dictionary).
	^jsonAssocs! !

!N4RestRawClient methodsFor: 'builder' stamp: 'mu 12/19/2011 23:40'!
newRelationshipIndexJson: uriOrNodeId key: key value: value
	| uri jsonAssocs |
	jsonAssocs := OrderedCollection new: 3.
	uri := uriOrNodeId asString.
	(self portableUtil string: uri beginsWith: 'http:') ifFalse: [uri := (self rootUri, 'relationship/', uri)].
	jsonAssocs add: ('uri' -> uri).
	jsonAssocs add: ('key' -> key).
	jsonAssocs add: ('value' -> value).
	^jsonAssocs! !

!N4RestRawClient methodsFor: 'builder' stamp: 'mu 4/22/2012 22:31'!
newRelationshipJson: uriOrNodeId type: type properties: assocs
	| uri jsonAssocs |
	jsonAssocs := OrderedCollection new: 3.
	uri := uriOrNodeId asString.
	(self portableUtil string: uri beginsWith: 'http:') ifFalse: [uri := (self rootUri, 'node/', uri)].
	jsonAssocs add: ('to' -> uri).
	jsonAssocs add: ('type' -> type).
	(assocs isNil or: [assocs isEmpty]) ifFalse: [
		jsonAssocs add: ('data' -> (self portableUtil dictionaryFromAssociations: assocs))
	].
	^jsonAssocs! !

!N4RestRawClient methodsFor: 'accessing' stamp: 'MasashiUmezawa 1/21/2013 01:14'!
nodeUri
	^ self rootUri , 'node'! !

!N4RestRawClient methodsFor: 'accessing' stamp: 'mu 12/2/2011 00:08'!
portableUtil
	^N4PortableUtil default! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 7/6/2013 20:23'!
queryByCypher: queryString
	^self queryByCypher: queryString params: Dictionary new! !

!N4RestRawClient methodsFor: 'actions' stamp: 'sy 6/4/2013 09:28'!
queryByCypher: queryString params: dictionary
	| json jsonString |
	json := self newQueryJson: queryString params: dictionary.
	jsonString := self portableUtil jsonStringFrom: json.
	^ self portableUtil httpJsonPost: (self rootUri, 'cypher') content: jsonString! !

!N4RestRawClient methodsFor: 'accessing' stamp: 'MasashiUmezawa 1/21/2013 01:15'!
relationshipUri
	^ self rootUri , 'relationship'! !

!N4RestRawClient methodsFor: 'actions-indexes' stamp: 'MasashiUmezawa 1/22/2013 02:06'!
removeNodeIndexes: indexName on: nodeId
	^ self portableUtil httpJsonDelete: (self indexUri / 'node' // indexName // nodeId) ! !

!N4RestRawClient methodsFor: 'actions-indexes' stamp: 'MasashiUmezawa 1/22/2013 02:06'!
removeNodeIndexes: indexName on: nodeId key: key
	^ self portableUtil httpJsonDelete: (self indexUri / 'node' // indexName // key // nodeId) ! !

!N4RestRawClient methodsFor: 'actions-indexes' stamp: 'MasashiUmezawa 1/22/2013 02:07'!
removeNodeIndexes: indexName on: nodeId key: key value: value
	^ self portableUtil httpJsonDelete: (self indexUri / 'node' // indexName // key // value // nodeId) ! !

!N4RestRawClient methodsFor: 'actions-indexes' stamp: 'MasashiUmezawa 1/22/2013 02:07'!
removeRelationshipIndexes: indexName on: relId
	^ self portableUtil httpJsonDelete: (self indexUri / 'relationship' // indexName // relId) ! !

!N4RestRawClient methodsFor: 'actions-indexes' stamp: 'MasashiUmezawa 1/22/2013 02:08'!
removeRelationshipIndexes: indexName on: relId key: key
	^ self portableUtil httpJsonDelete: (self indexUri / 'relationship' // indexName // key // relId) ! !

!N4RestRawClient methodsFor: 'actions-indexes' stamp: 'MasashiUmezawa 1/22/2013 02:09'!
removeRelationshipIndexes: indexName on: relId key: key value: value
	^ self portableUtil httpJsonDelete: (self indexUri / 'node' // indexName // key // value // relId) ! !

!N4RestRawClient methodsFor: 'accessing' stamp: 'mu 5/27/2013 16:27'!
rootUri
	^ rootUri ifNil: [self rootUri: N4Settings default rootUri. rootUri]! !

!N4RestRawClient methodsFor: 'accessing' stamp: 'MasashiUmezawa 1/21/2013 01:18'!
rootUri: anObject
	anObject isNil ifTrue: [^rootUri := nil].
	rootUri := N4Url  baseUrlString: anObject! !

!N4RestRawClient methodsFor: 'actions' stamp: 'MasashiUmezawa 1/22/2013 01:53'!
setProperties: properties nodeAt: nodeId
	| jsonString urlString |
	urlString := self nodeUri // nodeId / 'properties'.
	jsonString := self portableUtil jsonStringFrom: properties.
	^ self portableUtil httpJsonPut: urlString content: jsonString ! !

!N4RestRawClient methodsFor: 'actions' stamp: 'MasashiUmezawa 1/22/2013 01:53'!
setProperties: properties relationshipAt: relId
	| jsonString urlString |
	urlString := self relationshipUri // relId / 'properties'.
	jsonString := self portableUtil jsonStringFrom: properties.
	^ self portableUtil httpJsonPut: urlString content: jsonString ! !

!N4RestRawClient methodsFor: 'actions' stamp: 'MasashiUmezawa 1/22/2013 01:54'!
setProperty: propName to: value nodeAt: nodeId 
	| jsonString urlString |
	urlString := self nodeUri // nodeId / 'properties' // propName.
	jsonString := self portableUtil jsonStringFrom: value.
	^ self portableUtil httpJsonPut: urlString content: jsonString ! !

!N4RestRawClient methodsFor: 'actions' stamp: 'MasashiUmezawa 1/22/2013 01:54'!
setProperty: propName to: value relationshipAt: relId 
	| jsonString urlString |
	urlString := self relationshipUri // relId / 'properties' // propName.
	jsonString := self portableUtil jsonStringFrom: value.
	^ self portableUtil httpJsonPut: urlString content: jsonString ! !

!N4RestRawClient methodsFor: 'actions' stamp: 'MasashiUmezawa 1/22/2013 01:54'!
traverseFrom: nodeId using: traversalDescription
	| jsonString urlString |
	urlString := self nodeUri // nodeId / 'traverse' // traversalDescription returnType.
	jsonString := self portableUtil jsonStringFrom: traversalDescription asDictionary.
	^ self portableUtil httpJsonPost: urlString content: jsonString ! !
